# Run HADOLINT (https://hadolint.github.io/hadolint/) Dockerfile linter.
# Fails if Dokerfile is in violation of bests practices for Docker images:
# (https://docs.docker.com/engine/articles/dockerfile_best-practices/).
# Saves a codequality artifact with scan report results.
# Environment variables:
# - DOCKERFILE: Dockerfile name and location (default "./Dockerfile")
.hadolint:
  stage: lint
  image: registry.gitlab.com/gabrielarellano/docker-hadolint-with-jq:2.3.0-alpine
  variables:
    DOCKERFILE: ./Dockerfile
  script:
    - |
      if [ ! -e $DOCKERFILE ]; then
        echo "Failing stage ($DOCKERFILE not found)..."
        exit 21
      fi
    - hadolint --no-fail $DOCKERFILE
    # Run again to save codequality report
    - hadolint -f gitlab_codeclimate $DOCKERFILE > hadolint-gl-codequality.json
  after_script:
    # Check for codequality report (and merges if a previous gl-codequality.json exists)
    - |
      if [ -e hadolint-gl-codequality.json ]; then
        if [ ! -e $CI_PROJECT_DIR/gl-codequality.json ]; then
          mv hadolint-gl-codequality.json $CI_PROJECT_DIR/gl-codequality.json
        else
          echo "Updating previous codequality artifact..."
          cp $CI_PROJECT_DIR/gl-codequality.json previous-codequality.json
          jq -s '[.[][]]' previous-codequality.json hadolint-gl-codequality.json > $CI_PROJECT_DIR/gl-codequality.json
        fi
      fi
  allow_failure:
    exit_codes:
      # If stage is skipped mark as "Allow to fail"
      - 21
  artifacts:
    name: "$CI_JOB_NAME artifacts from $CI_PROJECT_NAME on $CI_COMMIT_REF_SLUG"
    expire_in: 30 day
    when: always
    reports:
      codequality:
        - $CI_PROJECT_DIR/gl-codequality.json
    paths:
      - $CI_PROJECT_DIR/gl-codequality.json
